# !/sbin/sh

###########################
## HGL restore by drakaz ##
###########################

# Backup/restore hgl lib on Galaxo/Galaxhero

LIBS="libhgl.so"

TMPDIR="/sdcard/TMPGALAXOHTC/"
UPDATEFILE="/sdcard/HTC.zip"
CHECKSUM="b344ca40307bd0fc425f2f84fff0a310"


	# Verification du fichier de maj
	if [ ! -s $UPDATEFILE ]
	then
		echo "Erreurs : le fichier de mise à jour HTC est absent. Veuillez déposer le fichier de mise à jour dans /sdcard/ renommé en $2 (/sdcard/$2)"
		exit 1
	else
		echo "Fichier mise à jour trouve : $UPDATEFILE"
	fi

	# On remount en rw
	/tmp/RECTOOLS/remountrw

	# Creation du rep temporaire
	mkdir $TMPDIR

	if [ ! -d $TMPDIR ]
	then
		echo "Erreur lors de la création du répértoire temporaire"
		exit 1	
	fi      

	# Extraction de l'image system
	echo -n "Extraction de l'image system"
	unzip $UPDATEFILE system.img -d $TMPDIR
	echo " "

	# Verification du fichier image
	if [ ! -s $TMPDIR/system.img ]
	then
		echo "Erreur lors de l'extraction du fichier image"
		rm -rf $TMPDIR
		exit 1
	fi

	# Verification du MD5
	echo -n "Verification du checksum"
	if [ ! $CHECKSUM = `md5sum $TMPDIR/system.img | awk -F " " '{print $1}'` ]
	then
		echo "Erreur de checksum, veuillez verifier la version de votre update"
		rm -rf $TMPDIR
		exit 1
	else
		echo "Checksum OK"
	fi	

	# Extraction du fichier image
	echo -n "Extraction du fichier image"
	cd $TMPDIR; unyaffs system.img


	# On vérifit l'extraction
	for i in `echo $LIBS`
	do
		if [ ! -s /$TMPDIR/lib/$i ]
		then
			echo "Erreurs d'extraction du fichier image : fichier /$TMPDIR/lib/$i absent"
			rm -rf $TMPDIR
			exit 1
		fi
	done

	# On restore la libl
	echo -n "Restauration de la librairie"
	for i in `echo $LIBS`
	do	
		cp /$TMPDIR/lib/$i  /system/lib/$i
	done	
	echo " "

	# On vérifit le restore
	for i in `echo $LIBS`
	do
		if [ ! -s /system/lib/$i ]
		then
			echo "Erreur de restauration : fichier /system/lib/$i absent"
			rm -rf $TMPDIR
			exit 1
		fi
	done
	echo "Restore successfull"
	rm -rf $TMPDIR
	sync
	/tmp/RECTOOLS/remountro
	exit 0




